package cokr.xit.fims.levy.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.crdn.Crdn;
import cokr.xit.fims.levy.LevyQuery;
import cokr.xit.fims.levy.Rdct;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 과태료 감경 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-30	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("rdctMapper")
public interface RdctMapper extends AbstractMapper {

	/**지정한 조건에 따라 과태료 감경 대장 목록을 조회하여 반환한다.<br />
	 * @param req 과태료 감경 대장 조회 조건
	 * @return 과태료 감경 대장 목록
	 */
	List<DataObject> selectRdctList(LevyQuery req);

	/**지정한 조건에 따라 과태료 감경 대장 객체들을 반환한다.
	 * @param req 과태료 감경 대장 조회 조건
	 * @return 과태료 감경 대장 객체 목록
	 */
	List<DataObject> selectRdcts(LevyQuery req);

	/**지정한 조건에 따라 과태료 감경 대장 객체의 마지막 1개를 반환한다.
	 * @param req 과태료 감경 대장 조회 조건
	 * @return 과태료 감경 대장 객체
	 */
	default DataObject selectRdctInfo(LevyQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 기본 정렬
		if (req.getOrderBy() == null) {
			req.setOrderBy("R.RDCT_ID DESC");
		}

		List<DataObject> rdcts = selectRdcts(req);

		return !rdcts.isEmpty() ? rdcts.get(0) : null;
	}

	/**과태료 감경 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"rdct" - 과태료 감경 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertRdct(Rdct rdct);

	/**과태료 감경 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"rdct" - 과태료 감경 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateRdct(Rdct rdct);

	/**지정한 과태료 감경 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"rdct" - 과태료 감경 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteRdct(Rdct rdct);

	/**지정한 단속 ID의 단속, 부과제외 정보를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 부과제외 정보
	 */
	DataObject selectCrdn(LevyQuery req);

	default DataObject selectCrdnInfo(String crdnId) {
		DataObject rdctInfo = selectCrdn(new LevyQuery().setCrdnId(crdnId));

		return rdctInfo;
	}

	/**단속(TB_CRDN) 대장의 금액을 수정한다.
	 * @param crdn 단속 대장
	 * @return 저장된 정보수
	 */
	int updateCrdnRdct(Crdn crdn);

}
